import solo_turnier.group
import pytest

@pytest.fixture(params=range(9))
def fix_pureClass(request):
    cases = (
        ('Kin', 'Kin.'),
        ('Kin.', 'Kin.'),
        ('Kinder', 'Kin.'),
        ('Jun', 'Jun.'),
        ('Jun.', 'Jun.'),
        ('Junioren', 'Jun.'),
        ('Jug', 'Jug.'),
        ('Jug.', 'Jug.'),
        ('Jugend', 'Jug.'),
    )
    return cases[request.param]

def test_pureClassParsing(fix_pureClass):
    className = fix_pureClass[0]
    expected = fix_pureClass[1]

    parser = solo_turnier.group.GroupParser()
    ret = parser.parseClass(className)

    assert isinstance(ret, solo_turnier.group.Group)
    assert str(ret) == expected

    assert parser.isPureClass(className)

@pytest.fixture(params=range(4))
def fix_combinedClass(request):
    cases = (
        ('Kin/Jun', 'Kin./Jun.'),
        ('Kin./Jun', 'Kin./Jun.'),
        ('Junioren/Jug', 'Jun./Jug.'),
        ('Jun/Jug', 'Jun./Jug.'),
    )
    return cases[request.param]

def test_combinedClassParsing(fix_combinedClass):
    className = fix_combinedClass[0]
    expected = fix_combinedClass[1]

    parser = solo_turnier.group.GroupParser()
    ret = parser.parseClass(className)

    assert isinstance(ret, solo_turnier.group.CombinedGroup)
    assert str(ret) == expected

    assert not parser.isPureClass(className)
